Remove the python confd server side code
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 DOCPP = $(top_srcdir)/autotools/docpp
31 REPLACE_VARS_SED = autotools/replace_vars.sed
32 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 SHELL_ENV_INIT = autotools/shell-env-init
35
36 # Note: these are automake-specific variables, and must be named after
37 # the directory + 'dir' suffix
38 clientdir = $(pkgpythondir)/client
39 hypervisordir = $(pkgpythondir)/hypervisor
40 httpdir = $(pkgpythondir)/http
41 masterddir = $(pkgpythondir)/masterd
42 confddir = $(pkgpythondir)/confd
43 rapidir = $(pkgpythondir)/rapi
44 serverdir = $(pkgpythondir)/server
45 watcherdir = $(pkgpythondir)/watcher
46 impexpddir = $(pkgpythondir)/impexpd
47 utilsdir = $(pkgpythondir)/utils
48 toolsdir = $(pkglibdir)/tools
49 iallocatorsdir = $(pkglibdir)/iallocators
50 pytoolsdir = $(pkgpythondir)/tools
51 docdir = $(datadir)/doc/$(PACKAGE)
52 myexeclibdir = $(pkglibdir)
53
54 # Delete output file if an error occurred while building it
55 .DELETE_ON_ERROR:
56
57 HTOOLS_DIRS = \
58         htools \
59         htools/Ganeti \
60         htools/Ganeti/Confd \
61         htools/Ganeti/HTools \
62         htools/Ganeti/HTools/Program \
63         htools/Ganeti/Query \
64         htest \
65         htest/Test \
66         htest/Test/Ganeti \
67         htest/Test/Ganeti/Confd \
68         htest/Test/Ganeti/HTools \
69         htest/Test/Ganeti/Query
70
71 DIRS = \
72         autotools \
73         daemons \
74         devel \
75         doc \
76         doc/examples \
77         doc/examples/hooks \
78         doc/examples/gnt-debug \
79         $(HTOOLS_DIRS) \
80         lib \
81         lib/client \
82         lib/build \
83         lib/confd \
84         lib/http \
85         lib/hypervisor \
86         lib/impexpd \
87         lib/masterd \
88         lib/rapi \
89         lib/server \
90         lib/tools \
91         lib/utils \
92         lib/watcher \
93         man \
94         qa \
95         test \
96         test/data \
97         test/data/ovfdata \
98         test/data/ovfdata/other \
99         htest/data \
100         htest/data/rapi \
101         htest/shelltests \
102         tools
103
104 BUILDTIME_DIR_AUTOCREATE = \
105         scripts \
106         $(APIDOC_DIR) \
107         $(APIDOC_PY_DIR) \
108         $(APIDOC_HS_DIR) \
109         $(APIDOC_HS_DIR)/Ganeti \
110         $(APIDOC_HS_DIR)/Ganeti/Confd \
111         $(APIDOC_HS_DIR)/Ganeti/HTools \
112         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
113         $(APIDOC_HS_DIR)/Ganeti/Query \
114         $(COVERAGE_DIR) \
115         $(COVERAGE_PY_DIR) \
116         $(COVERAGE_HS_DIR) \
117         .hpc
118
119 BUILDTIME_DIRS = \
120         $(BUILDTIME_DIR_AUTOCREATE) \
121         doc/html
122
123 DIRCHECK_EXCLUDE = \
124         $(BUILDTIME_DIRS) \
125         ganeti-[0-9]*.[0-9]*.[0-9]* \
126         doc/html/_*
127
128 # some helper vars
129 COVERAGE_DIR = doc/coverage
130 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
131 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
132 APIDOC_DIR = doc/api
133 APIDOC_PY_DIR = $(APIDOC_DIR)/py
134 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
135
136 MAINTAINERCLEANFILES = \
137         $(docpng) \
138         $(maninput) \
139         doc/install-quick.rst \
140         doc/news.rst \
141         doc/upgrade.rst \
142         vcs-version
143
144 maintainer-clean-local:
145         rm -rf $(BUILDTIME_DIRS)
146
147 CLEANFILES = \
148         $(addsuffix /*.py[co],$(DIRS)) \
149         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
150         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
151         $(PYTHON_BOOTSTRAP) \
152         epydoc.conf \
153         $(REPLACE_VARS_SED) \
154         $(SHELL_ENV_INIT) \
155         daemons/daemon-util \
156         daemons/ganeti-cleaner \
157         daemons/ganeti-master-cleaner \
158         devel/upload \
159         $(BUILT_EXAMPLES) \
160         doc/examples/bash_completion \
161         doc/examples/bash_completion-debug \
162         lib/_generated_rpc.py \
163         $(man_MANS) \
164         $(manhtml) \
165         tools/kvm-ifup \
166         tools/vcluster-setup \
167         stamp-directories \
168         stamp-srclinks \
169         $(nodist_pkgpython_PYTHON) \
170         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
171         $(HS_BUILT_TEST_HELPERS) \
172         htools/ganeti-confd \
173         .hpc/*.mix htools/*.tix htest/*.tix \
174         doc/hs-lint.html
175
176 GENERATED_FILES = \
177         $(built_base_sources) \
178         $(BUILT_PYTHON_SOURCES) \
179         $(PYTHON_BOOTSTRAP)
180
181 HTOOLS_GENERATED_FILES =
182 if WANT_HTOOLS
183 HTOOLS_GENERATED_FILES += $(HS_PROGS)
184 if ENABLE_CONFD
185 HTOOLS_GENERATED_FILES += htools/hconfd
186 endif
187 endif
188
189 built_base_sources = \
190         stamp-directories \
191         stamp-srclinks
192
193 built_python_base_sources = \
194         lib/_autoconf.py \
195         lib/_vcsversion.py
196
197 BUILT_PYTHON_SOURCES = \
198         $(built_python_base_sources) \
199         lib/_generated_rpc.py
200
201 # Generating the RPC wrappers depends on many things, so make sure
202 # it's built at the end of the built sources
203 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
204
205 # these are all built from the underlying %.in sources
206 BUILT_EXAMPLES = \
207         doc/examples/ganeti-kvm-poweroff.initd \
208         doc/examples/ganeti.cron \
209         doc/examples/ganeti.initd \
210         doc/examples/gnt-config-backup \
211         doc/examples/hooks/ipsec
212
213 nodist_pkgpython_PYTHON = \
214         $(BUILT_PYTHON_SOURCES)
215
216 noinst_PYTHON = \
217         lib/build/__init__.py \
218         lib/build/sphinx_ext.py \
219         lib/build/shell_example_lexer.py
220
221 pkgpython_PYTHON = \
222         lib/__init__.py \
223         lib/asyncnotifier.py \
224         lib/backend.py \
225         lib/bdev.py \
226         lib/bootstrap.py \
227         lib/cli.py \
228         lib/cmdlib.py \
229         lib/compat.py \
230         lib/config.py \
231         lib/constants.py \
232         lib/daemon.py \
233         lib/errors.py \
234         lib/ht.py \
235         lib/jqueue.py \
236         lib/jstore.py \
237         lib/locking.py \
238         lib/luxi.py \
239         lib/mcpu.py \
240         lib/netutils.py \
241         lib/objects.py \
242         lib/objectutils.py \
243         lib/opcodes.py \
244         lib/ovf.py \
245         lib/pathutils.py \
246         lib/qlang.py \
247         lib/query.py \
248         lib/rpc.py \
249         lib/rpc_defs.py \
250         lib/runtime.py \
251         lib/serializer.py \
252         lib/ssconf.py \
253         lib/ssh.py \
254         lib/storage.py \
255         lib/uidpool.py \
256         lib/vcluster.py \
257         lib/workerpool.py
258
259 client_PYTHON = \
260         lib/client/__init__.py \
261         lib/client/gnt_backup.py \
262         lib/client/gnt_cluster.py \
263         lib/client/gnt_debug.py \
264         lib/client/gnt_group.py \
265         lib/client/gnt_instance.py \
266         lib/client/gnt_job.py \
267         lib/client/gnt_node.py \
268         lib/client/gnt_os.py
269
270 hypervisor_PYTHON = \
271         lib/hypervisor/__init__.py \
272         lib/hypervisor/hv_base.py \
273         lib/hypervisor/hv_chroot.py \
274         lib/hypervisor/hv_fake.py \
275         lib/hypervisor/hv_kvm.py \
276         lib/hypervisor/hv_lxc.py \
277         lib/hypervisor/hv_xen.py
278
279 rapi_PYTHON = \
280         lib/rapi/__init__.py \
281         lib/rapi/baserlib.py \
282         lib/rapi/client.py \
283         lib/rapi/client_utils.py \
284         lib/rapi/connector.py \
285         lib/rapi/rlib2.py \
286         lib/rapi/testutils.py
287
288 http_PYTHON = \
289         lib/http/__init__.py \
290         lib/http/auth.py \
291         lib/http/client.py \
292         lib/http/server.py
293
294 confd_PYTHON = \
295         lib/confd/__init__.py \
296         lib/confd/client.py
297
298 masterd_PYTHON = \
299         lib/masterd/__init__.py \
300         lib/masterd/iallocator.py \
301         lib/masterd/instance.py
302
303 impexpd_PYTHON = \
304         lib/impexpd/__init__.py
305
306 watcher_PYTHON = \
307         lib/watcher/__init__.py \
308         lib/watcher/nodemaint.py \
309         lib/watcher/state.py
310
311 server_PYTHON = \
312         lib/server/__init__.py \
313         lib/server/masterd.py \
314         lib/server/noded.py \
315         lib/server/rapi.py
316
317 pytools_PYTHON = \
318         lib/tools/__init__.py \
319         lib/tools/ensure_dirs.py
320
321 utils_PYTHON = \
322         lib/utils/__init__.py \
323         lib/utils/algo.py \
324         lib/utils/filelock.py \
325         lib/utils/hash.py \
326         lib/utils/io.py \
327         lib/utils/log.py \
328         lib/utils/mlock.py \
329         lib/utils/nodesetup.py \
330         lib/utils/process.py \
331         lib/utils/retry.py \
332         lib/utils/text.py \
333         lib/utils/wrapper.py \
334         lib/utils/x509.py
335
336 docrst = \
337         doc/admin.rst \
338         doc/design-2.0.rst \
339         doc/design-2.1.rst \
340         doc/design-2.2.rst \
341         doc/design-2.3.rst \
342         doc/design-htools-2.3.rst \
343         doc/design-2.4.rst \
344         doc/design-2.5.rst \
345         doc/design-draft.rst \
346         doc/design-oob.rst \
347         doc/design-cpu-pinning.rst \
348         doc/design-query2.rst \
349         doc/design-x509-ca.rst \
350         doc/design-http-server.rst \
351         doc/design-impexp2.rst \
352         doc/design-lu-generated-jobs.rst \
353         doc/design-multi-reloc.rst \
354         doc/design-network.rst \
355         doc/design-chained-jobs.rst \
356         doc/design-ovf-support.rst \
357         doc/design-autorepair.rst \
358         doc/design-resource-model.rst \
359         doc/cluster-merge.rst \
360         doc/design-shared-storage.rst \
361         doc/design-node-state-cache.rst \
362         doc/design-virtual-clusters.rst \
363         doc/design-bulk-create.rst \
364         doc/design-query-splitting.rst \
365         doc/devnotes.rst \
366         doc/glossary.rst \
367         doc/hooks.rst \
368         doc/iallocator.rst \
369         doc/index.rst \
370         doc/install-quick.rst \
371         doc/install.rst \
372         doc/locking.rst \
373         doc/move-instance.rst \
374         doc/news.rst \
375         doc/ovfconverter.rst \
376         doc/rapi.rst \
377         doc/security.rst \
378         doc/upgrade.rst \
379         doc/virtual-cluster.rst \
380         doc/walkthrough.rst
381
382 HS_PROGS = htools/htools
383 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
384 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
385
386 HS_ALL_PROGS = $(HS_PROGS) htest/test htest/hpc-htools htools/hconfd
387 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
388 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
389
390 HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
391 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
392 HEXTRA =
393 # internal extra flags (used for htest/test mainly)
394 HEXTRA_INT =
395 # exclude options for coverage reports
396 HPCEXCL = --exclude Main \
397         --exclude Ganeti.Constants \
398         --exclude Ganeti.THH \
399         --exclude Ganeti.HTools.QC \
400         --exclude Ganeti.Version \
401         --exclude Test.Ganeti.TestCommon \
402         --exclude Test.Ganeti.TestHTools \
403         --exclude Test.Ganeti.TestHelper \
404         --exclude Test.Ganeti.TestImports \
405         $(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
406
407 HS_LIB_SRCS = \
408         htools/Ganeti/HTools/CLI.hs \
409         htools/Ganeti/HTools/Cluster.hs \
410         htools/Ganeti/HTools/Container.hs \
411         htools/Ganeti/HTools/ExtLoader.hs \
412         htools/Ganeti/HTools/Group.hs \
413         htools/Ganeti/HTools/IAlloc.hs \
414         htools/Ganeti/HTools/Instance.hs \
415         htools/Ganeti/HTools/Loader.hs \
416         htools/Ganeti/HTools/Luxi.hs \
417         htools/Ganeti/HTools/Node.hs \
418         htools/Ganeti/HTools/PeerMap.hs \
419         htools/Ganeti/HTools/Rapi.hs \
420         htools/Ganeti/HTools/Simu.hs \
421         htools/Ganeti/HTools/Text.hs \
422         htools/Ganeti/HTools/Types.hs \
423         htools/Ganeti/HTools/Utils.hs \
424         htools/Ganeti/HTools/Program.hs \
425         htools/Ganeti/HTools/Program/Hail.hs \
426         htools/Ganeti/HTools/Program/Hbal.hs \
427         htools/Ganeti/HTools/Program/Hcheck.hs \
428         htools/Ganeti/HTools/Program/Hinfo.hs \
429         htools/Ganeti/HTools/Program/Hscan.hs \
430         htools/Ganeti/HTools/Program/Hspace.hs \
431         htools/Ganeti/BasicTypes.hs \
432         htools/Ganeti/Common.hs \
433         htools/Ganeti/Compat.hs \
434         htools/Ganeti/Confd.hs \
435         htools/Ganeti/Confd/Server.hs \
436         htools/Ganeti/Confd/Utils.hs \
437         htools/Ganeti/Config.hs \
438         htools/Ganeti/Daemon.hs \
439         htools/Ganeti/Hash.hs \
440         htools/Ganeti/Jobs.hs \
441         htools/Ganeti/JSON.hs \
442         htools/Ganeti/Logging.hs \
443         htools/Ganeti/Luxi.hs \
444         htools/Ganeti/Objects.hs \
445         htools/Ganeti/OpCodes.hs \
446         htools/Ganeti/Path.hs \
447         htools/Ganeti/Query/Common.hs \
448         htools/Ganeti/Query/Filter.hs \
449         htools/Ganeti/Query/Group.hs \
450         htools/Ganeti/Query/Language.hs \
451         htools/Ganeti/Query/Node.hs \
452         htools/Ganeti/Query/Query.hs \
453         htools/Ganeti/Query/Server.hs \
454         htools/Ganeti/Query/Types.hs \
455         htools/Ganeti/Rpc.hs \
456         htools/Ganeti/Runtime.hs \
457         htools/Ganeti/Ssconf.hs \
458         htools/Ganeti/THH.hs
459
460 HS_TEST_SRCS = \
461         htest/Test/Ganeti/BasicTypes.hs \
462         htest/Test/Ganeti/Common.hs \
463         htest/Test/Ganeti/Daemon.hs \
464         htest/Test/Ganeti/Confd/Utils.hs \
465         htest/Test/Ganeti/HTools/CLI.hs \
466         htest/Test/Ganeti/HTools/Cluster.hs \
467         htest/Test/Ganeti/HTools/Container.hs \
468         htest/Test/Ganeti/HTools/Instance.hs \
469         htest/Test/Ganeti/HTools/Loader.hs \
470         htest/Test/Ganeti/HTools/Node.hs \
471         htest/Test/Ganeti/HTools/PeerMap.hs \
472         htest/Test/Ganeti/HTools/Simu.hs \
473         htest/Test/Ganeti/HTools/Text.hs \
474         htest/Test/Ganeti/HTools/Types.hs \
475         htest/Test/Ganeti/HTools/Utils.hs \
476         htest/Test/Ganeti/JSON.hs \
477         htest/Test/Ganeti/Jobs.hs \
478         htest/Test/Ganeti/Luxi.hs \
479         htest/Test/Ganeti/Objects.hs \
480         htest/Test/Ganeti/OpCodes.hs \
481         htest/Test/Ganeti/Query/Filter.hs \
482         htest/Test/Ganeti/Query/Language.hs \
483         htest/Test/Ganeti/Query/Query.hs \
484         htest/Test/Ganeti/Rpc.hs \
485         htest/Test/Ganeti/Ssconf.hs \
486         htest/Test/Ganeti/TestCommon.hs \
487         htest/Test/Ganeti/TestHTools.hs \
488         htest/Test/Ganeti/TestHelper.hs
489
490 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
491
492 HS_BUILT_SRCS = \
493         htest/Test/Ganeti/TestImports.hs \
494         htools/Ganeti/Constants.hs \
495         htools/Ganeti/Version.hs
496 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
497
498 $(RUN_IN_TEMPDIR): | stamp-directories
499
500 # Note: we use here an order-only prerequisite, as the contents of
501 # _autoconf.py are not actually influencing the html build output: it
502 # has to exist in order for the sphinx module to be loaded
503 # successfully, but we certainly don't want the docs to be rebuilt if
504 # it changes
505 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
506         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
507         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
508         | $(BUILT_PYTHON_SOURCES)
509         @test -n "$(SPHINX)" || \
510             { echo 'sphinx-build' not found during configure; exit 1; }
511         @mkdir_p@ $(dir $@)
512         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
513             -d . \
514             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
515             -D release="$(PACKAGE_VERSION)" \
516             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
517         rm -f doc/html/.buildinfo doc/html/objects.inv
518         touch $@
519
520 doc/html: doc/html/index.html
521
522 doc/install-quick.rst: INSTALL
523 doc/news.rst: NEWS
524 doc/upgrade.rst: UPGRADE
525
526 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
527         set -e; \
528         { echo '.. This file is automatically updated at build time from $<.'; \
529           echo '.. Do not edit.'; \
530           echo; \
531           cat $<; \
532         } > $@
533
534 docdot = \
535         doc/arch-2.0.dot \
536         doc/design-2.1-lock-acquire.dot \
537         doc/design-2.1-lock-release.dot
538
539 docpng = $(patsubst %.dot,%.png,$(docdot))
540
541 # Things to build but not to install (add it to EXTRA_DIST if it should be
542 # distributed)
543 noinst_DATA = \
544         devel/upload \
545         doc/html \
546         $(BUILT_EXAMPLES) \
547         doc/examples/bash_completion \
548         doc/examples/bash_completion-debug \
549         $(manhtml)
550
551 gnt_scripts = \
552         scripts/gnt-backup \
553         scripts/gnt-cluster \
554         scripts/gnt-debug \
555         scripts/gnt-group \
556         scripts/gnt-instance \
557         scripts/gnt-job \
558         scripts/gnt-node \
559         scripts/gnt-os
560
561 PYTHON_BOOTSTRAP_SBIN = \
562         daemons/ganeti-masterd \
563         daemons/ganeti-noded \
564         daemons/ganeti-watcher \
565         daemons/ganeti-rapi \
566         $(gnt_scripts)
567
568 PYTHON_BOOTSTRAP = \
569         $(PYTHON_BOOTSTRAP_SBIN) \
570         tools/ensure-dirs
571
572 qa_scripts = \
573         qa/__init__.py \
574         qa/ganeti-qa.py \
575         qa/qa_cluster.py \
576         qa/qa_config.py \
577         qa/qa_daemon.py \
578         qa/qa_env.py \
579         qa/qa_error.py \
580         qa/qa_group.py \
581         qa/qa_instance.py \
582         qa/qa_job.py \
583         qa/qa_node.py \
584         qa/qa_os.py \
585         qa/qa_rapi.py \
586         qa/qa_tags.py \
587         qa/qa_utils.py
588
589 bin_SCRIPTS =
590 if WANT_HTOOLS
591 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
592 install-exec-hook:
593         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
594 # FIXME: this is a hardcoded logic, instead of auto-resolving
595         $(LN_S) -f ../../../bin/htools \
596                    $(DESTDIR)$(iallocatorsdir)/hail
597         for role in $(HS_BIN_ROLES); do \
598                 $(LN_S) -f htools \
599                            $(DESTDIR)$(bindir)/$$role ; \
600         done
601 endif
602
603 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
604         @if [ -z "$(HTOOLS)" ]; then \
605           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
606           exit 1; \
607         fi
608         @if [ "$(notdir $@)" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
609           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
610           exit 1; \
611         fi
612         @rm -f $(notdir $@).tix
613         $(GHC) --make \
614           $(HFLAGS) \
615           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
616           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
617           $(HEXTRA) $(HEXTRA_INT) $@
618         @touch "$@"
619
620 # for the htest/test binary, we need to enable profiling/coverage
621 htest/test: HEXTRA_INT=-fhpc -ihtest
622
623 # we compile the hpc-htools binary with the program coverage
624 htest/hpc-htools: HEXTRA_INT=-fhpc
625
626 # test dependency
627 htest/offline-tests.sh: htest/hpc-htools
628
629 # rules for building profiling-enabled versions of the haskell
630 # programs: hs-prof does the full two-step build, whereas
631 # hs-prof-quick does only the final rebuild (hs-prof must have been
632 # run before)
633 .PHONY: hs-prof hs-prof-quick
634 hs-prof:
635         $(MAKE) $(AM_MAKEFLAGS) clean
636         $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
637         rm -f $(HS_ALL_PROGS)
638         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
639
640 hs-prof-quick:
641         $(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
642
643 dist_sbin_SCRIPTS = \
644         tools/ganeti-listrunner
645
646 nodist_sbin_SCRIPTS = \
647         $(PYTHON_BOOTSTRAP_SBIN) \
648         daemons/ganeti-cleaner \
649         daemons/ganeti-master-cleaner
650
651 if ENABLE_CONFD
652 htools/ganeti-confd: htools/hconfd
653         cp -f $< $@
654
655 nodist_sbin_SCRIPTS += htools/ganeti-confd
656 endif
657
658 python_scripts = \
659         tools/burnin \
660         tools/cfgshell \
661         tools/cfgupgrade \
662         tools/cfgupgrade12 \
663         tools/cluster-merge \
664         tools/confd-client \
665         tools/fmtjson \
666         tools/lvmstrap \
667         tools/move-instance \
668         tools/ovfconverter \
669         tools/setup-ssh \
670         tools/sanitize-config
671
672 dist_tools_SCRIPTS = \
673         $(python_scripts) \
674         tools/kvm-console-wrapper \
675         tools/xm-console-wrapper \
676         tools/master-ip-setup
677
678 nodist_tools_SCRIPTS = \
679         tools/vcluster-setup
680
681 pkglib_python_scripts = \
682         daemons/import-export \
683         tools/check-cert-expired
684
685 nodist_pkglib_python_scripts = \
686         tools/ensure-dirs
687
688 myexeclib_SCRIPTS = \
689         daemons/daemon-util \
690         tools/kvm-ifup \
691         $(pkglib_python_scripts)
692
693 nodist_myexeclib_SCRIPTS = \
694         $(nodist_pkglib_python_scripts)
695
696 EXTRA_DIST = \
697         NEWS \
698         UPGRADE \
699         epydoc.conf.in \
700         pylintrc \
701         autotools/build-bash-completion \
702         autotools/build-rpc \
703         autotools/check-header \
704         autotools/check-python-code \
705         autotools/check-imports \
706         autotools/check-man-dashes \
707         autotools/check-man-warnings \
708         autotools/check-news \
709         autotools/check-tar \
710         autotools/check-version \
711         autotools/convert-constants \
712         autotools/docpp \
713         autotools/gen-coverage \
714         autotools/testrunner \
715         autotools/wrong-hardcoded-paths \
716         $(RUN_IN_TEMPDIR) \
717         daemons/daemon-util.in \
718         daemons/ganeti-cleaner.in \
719         daemons/ganeti-master-cleaner.in \
720         $(pkglib_python_scripts) \
721         devel/upload.in \
722         tools/kvm-ifup.in \
723         tools/vcluster-setup.in \
724         $(docdot) \
725         $(docpng) \
726         $(docrst) \
727         doc/conf.py \
728         doc/html \
729         $(BUILT_EXAMPLES:%=%.in) \
730         doc/examples/ganeti.default \
731         doc/examples/ganeti.default-debug \
732         doc/examples/hooks/ethers \
733         doc/examples/gnt-debug/README \
734         doc/examples/gnt-debug/delay0.json \
735         doc/examples/gnt-debug/delay50.json \
736         test/lockperf.py \
737         test/testutils.py \
738         test/mocks.py \
739         $(dist_TESTS) \
740         $(TEST_FILES) \
741         man/footer.rst \
742         $(manrst) \
743         $(maninput) \
744         qa/qa-sample.json \
745         $(qa_scripts) \
746         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
747         $(HS_PROG_SRCS) \
748         htools/lint-hints.hs \
749         htest/cli-tests-defs.sh \
750         htest/offline-test.sh
751
752 man_MANS = \
753         man/ganeti.7 \
754         man/ganeti-cleaner.8 \
755         man/ganeti-master-cleaner.8 \
756         man/ganeti-confd.8 \
757         man/ganeti-listrunner.8 \
758         man/ganeti-masterd.8 \
759         man/ganeti-noded.8 \
760         man/ganeti-os-interface.7 \
761         man/ganeti-rapi.8 \
762         man/ganeti-watcher.8 \
763         man/gnt-backup.8 \
764         man/gnt-cluster.8 \
765         man/gnt-debug.8 \
766         man/gnt-group.8 \
767         man/gnt-instance.8 \
768         man/gnt-job.8 \
769         man/gnt-node.8 \
770         man/gnt-os.8 \
771         man/hail.1 \
772         man/hbal.1 \
773         man/hcheck.1 \
774         man/hinfo.1 \
775         man/hscan.1 \
776         man/hspace.1 \
777         man/htools.1
778
779 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
780 manhtml = $(patsubst %.rst,%.html,$(manrst))
781 mangen = $(patsubst %.rst,%.gen,$(manrst))
782 maninput = \
783         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
784         $(patsubst %.html,%.html.in,$(manhtml)) \
785         man/footer.man man/footer.html $(mangen)
786
787 TEST_FILES = \
788         test/data/bdev-drbd-8.0.txt \
789         test/data/bdev-drbd-8.3.txt \
790         test/data/bdev-drbd-disk.txt \
791         test/data/bdev-drbd-net-ip4.txt \
792         test/data/bdev-drbd-net-ip6.txt \
793         test/data/cert1.pem \
794         test/data/ip-addr-show-dummy0.txt \
795         test/data/ip-addr-show-lo-ipv4.txt \
796         test/data/ip-addr-show-lo-ipv6.txt \
797         test/data/ip-addr-show-lo-oneline-ipv4.txt \
798         test/data/ip-addr-show-lo-oneline-ipv6.txt \
799         test/data/ip-addr-show-lo-oneline.txt \
800         test/data/ip-addr-show-lo.txt \
801         test/data/proc_drbd8.txt \
802         test/data/proc_drbd80-emptyline.txt \
803         test/data/proc_drbd83.txt \
804         test/data/proc_drbd83_sync.txt \
805         test/data/proc_drbd83_sync_krnl2.6.39.txt \
806         test/data/kvm_1.0_help.txt \
807         test/data/kvm_0.15.90_help.txt \
808         test/data/kvm_0.12.5_help.txt \
809         test/data/kvm_0.9.1_help.txt \
810         test/data/sys_drbd_usermode_helper.txt \
811         test/data/ovfdata/compr_disk.vmdk.gz \
812         test/data/ovfdata/config.ini \
813         test/data/ovfdata/corrupted_resources.ovf \
814         test/data/ovfdata/empty.ini \
815         test/data/ovfdata/empty.ovf \
816         test/data/ovfdata/ganeti.mf \
817         test/data/ovfdata/ganeti.ovf \
818         test/data/ovfdata/gzip_disk.ovf \
819         test/data/ovfdata/new_disk.vmdk \
820         test/data/ovfdata/no_disk.ini \
821         test/data/ovfdata/no_disk_in_ref.ovf \
822         test/data/ovfdata/no_os.ini \
823         test/data/ovfdata/no_ovf.ova \
824         test/data/ovfdata/ova.ova \
825         test/data/ovfdata/second_disk.vmdk \
826         test/data/ovfdata/rawdisk.raw \
827         test/data/ovfdata/unsafe_path.ini \
828         test/data/ovfdata/virtualbox.ovf \
829         test/data/ovfdata/wrong_extension.ovd \
830         test/data/ovfdata/wrong_config.ini \
831         test/data/ovfdata/wrong_manifest.mf \
832         test/data/ovfdata/wrong_manifest.ovf \
833         test/data/ovfdata/wrong_ova.ova \
834         test/data/ovfdata/wrong_xml.ovf \
835         test/data/ovfdata/other/rawdisk.raw \
836         test/data/vgreduce-removemissing-2.02.02.txt \
837         test/data/vgreduce-removemissing-2.02.66-fail.txt \
838         test/data/vgreduce-removemissing-2.02.66-ok.txt \
839         test/data/vgs-missing-pvs-2.02.02.txt \
840         test/data/vgs-missing-pvs-2.02.66.txt \
841         test/import-export_unittest-helper \
842         test/gnt-cli.test \
843         test/ganeti-cli.test \
844         htest/shelltests/htools-balancing.test \
845         htest/shelltests/htools-basic.test \
846         htest/shelltests/htools-dynutil.test \
847         htest/shelltests/htools-excl.test \
848         htest/shelltests/htools-hail.test \
849         htest/shelltests/htools-hspace.test \
850         htest/shelltests/htools-invalid.test \
851         htest/shelltests/htools-multi-group.test \
852         htest/shelltests/htools-no-backend.test \
853         htest/shelltests/htools-rapi.test \
854         htest/shelltests/htools-single-group.test \
855         htest/shelltests/htools-text-backend.test \
856         htest/data/hail-alloc-drbd.json \
857         htest/data/hail-change-group.json \
858         htest/data/hail-invalid-reloc.json \
859         htest/data/hail-node-evac.json \
860         htest/data/hail-reloc-drbd.json \
861         htest/data/hbal-split-insts.data \
862         htest/data/common-suffix.data \
863         htest/data/invalid-node.data \
864         htest/data/missing-resources.data \
865         htest/data/rapi/groups.json \
866         htest/data/rapi/info.json \
867         htest/data/rapi/instances.json \
868         htest/data/rapi/nodes.json
869
870 python_tests = \
871         doc/examples/rapi_testutils.py \
872         test/ganeti.asyncnotifier_unittest.py \
873         test/ganeti.backend_unittest.py \
874         test/ganeti.bdev_unittest.py \
875         test/ganeti.cli_unittest.py \
876         test/ganeti.client.gnt_cluster_unittest.py \
877         test/ganeti.client.gnt_instance_unittest.py \
878         test/ganeti.daemon_unittest.py \
879         test/ganeti.cmdlib_unittest.py \
880         test/ganeti.compat_unittest.py \
881         test/ganeti.confd.client_unittest.py \
882         test/ganeti.config_unittest.py \
883         test/ganeti.constants_unittest.py \
884         test/ganeti.errors_unittest.py \
885         test/ganeti.hooks_unittest.py \
886         test/ganeti.ht_unittest.py \
887         test/ganeti.http_unittest.py \
888         test/ganeti.hypervisor_unittest.py \
889         test/ganeti.hypervisor.hv_chroot_unittest.py \
890         test/ganeti.hypervisor.hv_fake_unittest.py \
891         test/ganeti.hypervisor.hv_kvm_unittest.py \
892         test/ganeti.hypervisor.hv_lxc_unittest.py \
893         test/ganeti.hypervisor.hv_xen_unittest.py \
894         test/ganeti.impexpd_unittest.py \
895         test/ganeti.jqueue_unittest.py \
896         test/ganeti.jstore_unittest.py \
897         test/ganeti.locking_unittest.py \
898         test/ganeti.luxi_unittest.py \
899         test/ganeti.masterd.iallocator_unittest.py \
900         test/ganeti.masterd.instance_unittest.py \
901         test/ganeti.mcpu_unittest.py \
902         test/ganeti.netutils_unittest.py \
903         test/ganeti.objects_unittest.py \
904         test/ganeti.objectutils_unittest.py \
905         test/ganeti.opcodes_unittest.py \
906         test/ganeti.ovf_unittest.py \
907         test/ganeti.qlang_unittest.py \
908         test/ganeti.query_unittest.py \
909         test/ganeti.rapi.baserlib_unittest.py \
910         test/ganeti.rapi.client_unittest.py \
911         test/ganeti.rapi.resources_unittest.py \
912         test/ganeti.rapi.rlib2_unittest.py \
913         test/ganeti.rapi.testutils_unittest.py \
914         test/ganeti.rpc_unittest.py \
915         test/ganeti.runtime_unittest.py \
916         test/ganeti.serializer_unittest.py \
917         test/ganeti.ssh_unittest.py \
918         test/ganeti.storage_unittest.py \
919         test/ganeti.tools.ensure_dirs_unittest.py \
920         test/ganeti.uidpool_unittest.py \
921         test/ganeti.utils.algo_unittest.py \
922         test/ganeti.utils.filelock_unittest.py \
923         test/ganeti.utils.hash_unittest.py \
924         test/ganeti.utils.io_unittest.py \
925         test/ganeti.utils.io_unittest-runasroot.py \
926         test/ganeti.utils.log_unittest.py \
927         test/ganeti.utils.mlock_unittest.py \
928         test/ganeti.utils.nodesetup_unittest.py \
929         test/ganeti.utils.process_unittest.py \
930         test/ganeti.utils.retry_unittest.py \
931         test/ganeti.utils.text_unittest.py \
932         test/ganeti.utils.wrapper_unittest.py \
933         test/ganeti.utils.x509_unittest.py \
934         test/ganeti.utils_unittest.py \
935         test/ganeti.vcluster_unittest.py \
936         test/ganeti.workerpool_unittest.py \
937         test/qa.qa_config_unittest.py \
938         test/cfgupgrade_unittest.py \
939         test/docs_unittest.py \
940         test/pycurl_reset_unittest.py \
941         test/tempfile_fork_unittest.py
942
943 haskell_tests = htest/test
944
945 dist_TESTS = \
946         test/check-cert-expired_unittest.bash \
947         test/daemon-util_unittest.bash \
948         test/ganeti-cleaner_unittest.bash \
949         test/import-export_unittest.bash \
950         test/cli-test.bash \
951         test/bash_completion.bash \
952         $(python_tests)
953
954 nodist_TESTS =
955 check_SCRIPTS =
956
957 if WANT_HTOOLSTESTS
958 nodist_TESTS += $(haskell_tests)
959 dist_TESTS += htest/offline-test.sh
960 check_SCRIPTS += htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
961 endif
962
963 TESTS = $(dist_TESTS) $(nodist_TESTS)
964
965 # Environment for all tests
966 PLAIN_TESTS_ENVIRONMENT = \
967         PYTHONPATH=. \
968         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
969         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
970         $(RUN_IN_TEMPDIR)
971
972 # Environment for tests run by automake
973 TESTS_ENVIRONMENT = \
974         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
975
976 all_python_code = \
977         $(dist_sbin_SCRIPTS) \
978         $(python_scripts) \
979         $(pkglib_python_scripts) \
980         $(nodist_pkglib_python_scripts) \
981         $(python_tests) \
982         $(pkgpython_PYTHON) \
983         $(client_PYTHON) \
984         $(hypervisor_PYTHON) \
985         $(rapi_PYTHON) \
986         $(server_PYTHON) \
987         $(pytools_PYTHON) \
988         $(http_PYTHON) \
989         $(confd_PYTHON) \
990         $(masterd_PYTHON) \
991         $(impexpd_PYTHON) \
992         $(utils_PYTHON) \
993         $(watcher_PYTHON) \
994         $(noinst_PYTHON) \
995         $(qa_scripts)
996
997 srclink_files = \
998         man/footer.rst \
999         test/check-cert-expired_unittest.bash \
1000         test/daemon-util_unittest.bash \
1001         test/ganeti-cleaner_unittest.bash \
1002         test/import-export_unittest.bash \
1003         test/cli-test.bash \
1004         test/bash_completion.bash \
1005         htest/offline-test.sh \
1006         htest/cli-tests-defs.sh \
1007         $(all_python_code) \
1008         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1009
1010 check_python_code = \
1011         $(BUILD_BASH_COMPLETION) \
1012         $(CHECK_IMPORTS) \
1013         $(CHECK_HEADER) \
1014         $(DOCPP) \
1015         $(all_python_code)
1016
1017 lint_python_code = \
1018         ganeti \
1019         ganeti/http/server.py \
1020         $(dist_sbin_SCRIPTS) \
1021         $(python_scripts) \
1022         $(pkglib_python_scripts) \
1023         $(BUILD_BASH_COMPLETION) \
1024         $(CHECK_IMPORTS) \
1025         $(CHECK_HEADER) \
1026         $(DOCPP) \
1027         $(PYTHON_BOOTSTRAP)
1028
1029 standalone_python_modules = \
1030         lib/rapi/client.py \
1031         tools/ganeti-listrunner
1032
1033 pep8_python_code = \
1034         ganeti \
1035         ganeti/http/server.py \
1036         $(dist_sbin_SCRIPTS) \
1037         $(python_scripts) \
1038         $(pkglib_python_scripts) \
1039         $(BUILD_BASH_COMPLETION) \
1040         $(CHECK_HEADER) \
1041         $(DOCPP) \
1042         $(PYTHON_BOOTSTRAP) \
1043         qa
1044
1045 test/daemon-util_unittest.bash: daemons/daemon-util
1046
1047 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner \
1048   daemons/ganeti-master-cleaner
1049
1050 test/bash_completion.bash: doc/examples/bash_completion-debug
1051
1052 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1053         sed -f $(REPLACE_VARS_SED) < $< > $@
1054         chmod +x $@
1055
1056 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
1057         sed -f $(REPLACE_VARS_SED) < $< > $@
1058         chmod u+x $@
1059
1060 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1061         sed -f $(REPLACE_VARS_SED) < $< > $@
1062         chmod +x $@
1063
1064 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1065         sed -f $(REPLACE_VARS_SED) < $< > $@
1066         chmod +x $@
1067
1068 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1069         sed -f $(REPLACE_VARS_SED) < $< > $@
1070
1071 doc/examples/bash_completion: BC_ARGS = --compact
1072 doc/examples/bash_completion-debug: BC_ARGS =
1073
1074 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1075         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1076         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1077         $(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1078         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1079           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1080
1081 doc/%.png: doc/%.dot
1082         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1083         $(DOT) -Tpng -o $@ $<
1084
1085 man/footer.man: man/footer.rst
1086         @test -n "$(PANDOC)" || \
1087           { echo 'pandoc' not found during configure; exit 1; }
1088         $(PANDOC) -f rst -t man -o $@ $<
1089
1090 man/footer.html: man/footer.rst
1091         @test -n "$(PANDOC)" || \
1092           { echo 'pandoc' not found during configure; exit 1; }
1093         $(PANDOC) -f rst -t html -o $@ $<
1094
1095 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1096         lib/build/shell_example_lexer.py \
1097         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1098         @echo "Checking $< for hardcoded paths..."
1099         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1100           echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1101           exit 1; \
1102         fi
1103         set -e ; \
1104         trap 'echo auto-removing $@; rm $@' EXIT; \
1105         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1106         trap - EXIT
1107
1108 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1109         @test -n "$(PANDOC)" || \
1110           { echo 'pandoc' not found during configure; exit 1; }
1111         set -o pipefail ; \
1112         trap 'echo auto-removing $@; rm $@' EXIT; \
1113         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1114           sed -e 's/\\@/@/g' > $@; \
1115         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1116         $(CHECK_MAN_DASHES) $@; \
1117         trap - EXIT
1118
1119
1120 man/%.html.in: man/%.gen man/footer.html
1121         @test -n "$(PANDOC)" || \
1122           { echo 'pandoc' not found during configure; exit 1; }
1123         set -o pipefail ; \
1124         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1125           sed -e 's/\\@/@/g' > $@
1126
1127 man/%: man/%.in  $(REPLACE_VARS_SED)
1128         sed -f $(REPLACE_VARS_SED) < $< > $@
1129
1130 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1131         sed -f $(REPLACE_VARS_SED) < $< > $@
1132
1133 vcs-version:
1134         if test -d .git; then \
1135           git describe > $@; \
1136         elif test ! -f $@ ; then \
1137           echo "Cannot auto-generate $@ file"; exit 1; \
1138         fi
1139
1140 .PHONY: clean-vcs-version
1141 clean-vcs-version:
1142         rm -f vcs-version
1143
1144 .PHONY: regen-vcs-version
1145 regen-vcs-version:
1146         set -e; \
1147         cd $(srcdir); \
1148         if test -d .git; then \
1149           $(MAKE) $(AM_MAKEFLAGS) clean-vcs-version; \
1150           $(MAKE) $(AM_MAKEFLAGS) vcs-version; \
1151         fi
1152
1153 htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1154         vcs-version $(built_base_sources)
1155         set -e; \
1156         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1157         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1158
1159 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1160         lib/constants.py lib/_autoconf.py lib/luxi.py \
1161         $(CONVERT_CONSTANTS) $(built_base_sources) \
1162         | lib/_vcsversion.py
1163         set -e; \
1164         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1165
1166 htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1167         $(built_base_sources)
1168         set -e; \
1169         { cat $< ; \
1170           echo ; \
1171           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1172             echo "import $$name ()" ; \
1173           done ; \
1174         } > $@
1175
1176 lib/_autoconf.py: Makefile | stamp-directories
1177         set -e; \
1178         { echo '# This file is automatically generated, do not edit!'; \
1179           echo '#'; \
1180           echo ''; \
1181           echo '"""Build-time configuration for Ganeti.'; \
1182           echo '';\
1183           echo 'This file is autogenerated by the build process.'; \
1184           echo 'For any changes you need to re-run ./configure (and'; \
1185           echo 'not edit by hand).'; \
1186           echo ''; \
1187           echo '"""'; \
1188           echo ''; \
1189           echo '# pylint: disable=C0301,C0324'; \
1190           echo '# because this is autogenerated, we do not want'; \
1191           echo '# style warnings' ; \
1192           echo ''; \
1193           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1194           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1195           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1196           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1197           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1198           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1199           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1200           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1201           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1202           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1203           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1204           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1205           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1206           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1207           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1208           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1209           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1210           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1211           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1212           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1213           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1214           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1215           echo "KVM_PATH = '$(KVM_PATH)'"; \
1216           echo "IP_PATH = '$(IP_PATH)'"; \
1217           echo "SOCAT_PATH = '$(SOCAT)'"; \
1218           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1219           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1220           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1221           echo "TOOLSDIR = '$(toolsdir)'"; \
1222           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1223           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1224           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1225           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1226           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1227           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1228           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1229           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1230           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1231           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1232           echo "RAPI_USER = '$(RAPI_USER)'"; \
1233           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1234           echo "CONFD_USER = '$(CONFD_USER)'"; \
1235           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1236           echo "NODED_USER = '$(NODED_USER)'"; \
1237           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1238           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1239           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1240           if [ "$(HTOOLS)" ]; then \
1241             echo "HTOOLS = True"; \
1242           else \
1243             echo "HTOOLS = False"; \
1244           fi; \
1245           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1246           echo "XEN_CMD = '$(XEN_CMD)'"; \
1247           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1248         } > $@
1249
1250 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1251         set -e; \
1252         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1253         { echo '# This file is automatically generated, do not edit!'; \
1254           echo '#'; \
1255           echo ''; \
1256           echo '"""Build-time VCS version number for Ganeti.'; \
1257           echo '';\
1258           echo 'This file is autogenerated by the build process.'; \
1259           echo 'For any changes you need to re-run ./configure (and'; \
1260           echo 'not edit by hand).'; \
1261           echo ''; \
1262           echo '"""'; \
1263           echo ''; \
1264           echo '# pylint: disable=C0301,C0324'; \
1265           echo '# because this is autogenerated, we do not want'; \
1266           echo '# style warnings' ; \
1267           echo ''; \
1268           echo "VCS_VERSION = '$$VCSVER'"; \
1269         } > $@
1270
1271 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1272         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1273
1274 $(SHELL_ENV_INIT): Makefile stamp-directories
1275         set -e; \
1276         { echo '# Allow overriding for tests'; \
1277           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1278           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1279           echo; \
1280           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1281           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1282           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1283           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1284           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1285         } > $@
1286
1287 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1288         set -e; \
1289         { echo 's#@PREFIX@#$(prefix)#g'; \
1290           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1291           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1292           echo 's#@BINDIR@#$(bindir)#g'; \
1293           echo 's#@SBINDIR@#$(sbindir)#g'; \
1294           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1295           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1296           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1297           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1298           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1299           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1300           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1301           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1302           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1303           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1304           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1305           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1306           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1307           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1308           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1309           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1310           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1311           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1312           echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1313           echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1314           echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1315           echo; \
1316           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1317           echo '  r $(SHELL_ENV_INIT)'; \
1318           echo '  d'; \
1319           echo '}'; \
1320         } > $@
1321
1322 # Using deferred evaluation
1323 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1324 daemons/ganeti-watcher: MODULE = ganeti.watcher
1325 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1326 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1327 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1328
1329 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1330         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1331         set -e; \
1332         { echo '#!/usr/bin/python'; \
1333           echo '# This file is automatically generated, do not edit!'; \
1334           echo "# Edit $(MODULE) instead."; \
1335           echo; \
1336           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1337           echo; \
1338           echo '# pylint: disable=C0103'; \
1339           echo '# C0103: Invalid name'; \
1340           echo; \
1341           echo 'import sys'; \
1342           echo 'import $(MODULE) as main'; \
1343           echo; \
1344           echo '# Temporarily alias commands until bash completion'; \
1345           echo '# generator is changed'; \
1346           echo 'if hasattr(main, "commands"):'; \
1347           echo '  commands = main.commands # pylint: disable=E1101'; \
1348           echo 'if hasattr(main, "aliases"):'; \
1349           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1350           echo; \
1351           echo 'if __name__ == "__main__":'; \
1352           echo '  sys.exit(main.Main())'; \
1353         } > $@
1354         chmod u+x $@
1355
1356 $(HS_BUILT_TEST_HELPERS): Makefile
1357         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1358         set -e; \
1359         { echo '#!/bin/sh'; \
1360           echo '# This file is automatically generated, do not edit!'; \
1361           echo "# Edit Makefile.am instead."; \
1362           echo; \
1363           echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1364         } > $@
1365         chmod u+x $@
1366
1367 stamp-directories: Makefile
1368         $(MAKE) $(AM_MAKEFLAGS) ganeti
1369         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1370         touch $@
1371
1372 # We need to create symlinks because "make distcheck" will not install Python
1373 # files when building.
1374 stamp-srclinks: Makefile | stamp-directories
1375         set -e; \
1376         for i in $(srclink_files); do \
1377                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1378                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1379                 fi; \
1380         done
1381         touch $@
1382
1383 .PHONY: ganeti
1384 ganeti:
1385         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1386
1387 .PHONY: check-dirs
1388 check-dirs: $(GENERATED_FILES)
1389         @set -e; \
1390         find . -type d \( \( -name . \) -o \( \
1391                 -name .git -o \
1392                 -name autom4te.cache \
1393                 \) -prune -o -print \) | { \
1394                 error=; \
1395                 while read dir; do \
1396                         case "$$dir" in \
1397                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1398                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1399                         esac; \
1400                 done; \
1401                 for dir in $(DIRS); do \
1402                         if ! test -d "$$dir"; then \
1403                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1404                                 error=1; \
1405                         fi \
1406                 done; \
1407                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1408         }
1409
1410 .PHONY: check-local
1411 check-local: check-dirs $(GENERATED_FILES)
1412         $(CHECK_PYTHON_CODE) $(check_python_code)
1413         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1414         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1415         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1416         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1417         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1418         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1419                 echo "Incorrect version in README, expected $$expver"; \
1420                 exit 1; \
1421         fi; \
1422         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst; do \
1423                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1424                         "Documents Ganeti version $$expver"; then \
1425                         echo "Incorrect version in $$file, expected $$expver"; \
1426                         exit 1; \
1427                 fi; \
1428         done
1429
1430 .PHONY: hs-check
1431 hs-check: htest/test htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
1432         @rm -f test.tix
1433         ./htest/test
1434         HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1435
1436 # E111: indentation is not a multiple of four
1437 # E121: continuation line indentation is not a multiple of four
1438 #       (since our indent level is not 4)
1439 # E125: continuation line does not distinguish itself from next logical line
1440 #       (since our indent level is not 4)
1441 # E127: continuation line over-indented for visual indent
1442 #       (since our indent level is not 4)
1443 # note: do NOT add E128 here; it's a valid style error in most cases!
1444 # I've seen real errors, but also some cases were we indent wrongly
1445 # due to line length; try to rework the cases where it is triggered,
1446 # instead of silencing it
1447 # E261: at least two spaces before inline comment
1448 # E501: line too long (80 characters)
1449 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1450
1451 # For excluding pep8 expects filenames only, not whole paths
1452 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1453
1454 LINT_TARGETS = pylint pylint-qa
1455 if HAS_PEP8
1456 LINT_TARGETS += pep8
1457 endif
1458 if HAS_HLINT
1459 LINT_TARGETS += hlint
1460 endif
1461
1462 .PHONY: lint
1463 lint: $(LINT_TARGETS)
1464
1465 .PHONY: pylint
1466 pylint: $(GENERATED_FILES)
1467         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1468         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1469
1470 .PHONY: pylint-qa
1471 pylint-qa: $(GENERATED_FILES)
1472         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1473         cd $(top_srcdir)/qa && \
1474           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1475           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1476
1477 .PHONY: pep8
1478 pep8: $(GENERATED_FILES)
1479         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1480         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1481                 --repeat $(pep8_python_code)
1482
1483 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1484 .PHONY: hlint
1485 hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1486         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1487         if tty -s; then C="-c"; else C=""; fi; \
1488         $(HLINT) --report=doc/hs-lint.html --cross $$C \
1489           --ignore "Use first" \
1490           --ignore "Use comparing" \
1491           --ignore "Use on" \
1492           --ignore "Reduce duplication" \
1493           --ignore "Use &&&" \
1494           --ignore "Use void" \
1495           --hint htools/lint-hints \
1496           $(filter-out htools/Ganeti/THH.hs,$(HS_LIBTEST_SRCS))
1497
1498 # a dist hook rule for updating the vcs-version file; this is
1499 # hardcoded due to where it needs to build the file...
1500 dist-hook:
1501         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1502         rm -f $(top_distdir)/vcs-version
1503         cp -p $(srcdir)/vcs-version $(top_distdir)
1504
1505 # a distcheck hook rule for catching revision control directories
1506 distcheck-hook:
1507         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1508                 echo "Found revision control files in final archive." 1>&2; \
1509                 exit 1; \
1510         fi
1511         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1512                 echo "Found Python byte code in final archive." 1>&2; \
1513                 exit 1; \
1514         fi
1515         if find $(top_distdir) -name '*~' | grep .; then \
1516                 echo "Found backup files in final archive." 1>&2; \
1517                 exit 1; \
1518         fi
1519 # Empty files or directories should not be distributed. They can cause
1520 # unnecessary warnings for packagers. Directories used by automake during
1521 # distcheck must be excluded.
1522         if find $(top_distdir) -empty -and -not \( \
1523                         -path $(top_distdir)/_build -or \
1524                         -path $(top_distdir)/_inst \) | grep .; then \
1525                 echo "Found empty files or directories in final archive." 1>&2; \
1526                 exit 1; \
1527         fi
1528         if test -n "$(BUILD_RELEASE)" && \
1529            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1530                 echo "Found unreleased version in NEWS." >&2; \
1531                 exit 1; \
1532         fi
1533
1534 # When building a release, stricter checks should be used
1535 distcheck-release dist-release: export BUILD_RELEASE = 1
1536 distcheck-release: distcheck
1537
1538 distrebuildcheck: dist
1539         set -e; \
1540         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1541         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1542         cd $$builddir; \
1543         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1544         cd $(distdir); \
1545         ./configure; \
1546         $(MAKE) maintainer-clean; \
1547         cp $(abs_srcdir)/vcs-version .; \
1548         ./configure; \
1549         $(MAKE) $(AM_MAKEFLAGS)
1550
1551 dist-release: dist
1552         set -e; \
1553         for i in $(DIST_ARCHIVES); do \
1554                 echo -n "Checking $$i ... "; \
1555                 autotools/check-tar < $$i; \
1556                 echo OK; \
1557         done
1558
1559 install-exec-local:
1560         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1561           "$(DESTDIR)${localstatedir}/log/ganeti" \
1562           "$(DESTDIR)${localstatedir}/run/ganeti"
1563
1564 .PHONY: apidoc
1565 if WANT_HTOOLSAPIDOC
1566 apidoc: py-apidoc hs-apidoc
1567 else
1568 apidoc: py-apidoc
1569 endif
1570
1571 .PHONY: py-apidoc
1572 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1573         $(RUN_IN_TEMPDIR) epydoc -v \
1574                 --conf $(CURDIR)/epydoc.conf \
1575                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1576
1577 .PHONY: hs-apidoc
1578 hs-apidoc: $(HS_BUILT_SRCS)
1579         @test -n "$(HSCOLOUR)" || \
1580             { echo 'HsColour' not found during configure; exit 1; }
1581         @test -n "$(HADDOCK)" || \
1582             { echo 'haddock' not found during configure; exit 1; }
1583         rm -rf $(APIDOC_HS_DIR)/*
1584         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1585         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1586         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Query
1587         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1588         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1589         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1590         set -e ; \
1591         cd htools; \
1592         if [ "$(HTOOLS_NOCURL)" ]; \
1593         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1594         else OPTGHC=""; \
1595         fi; \
1596         if [ "$(HTOOLS_PARALLEL3)" ]; \
1597         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1598         fi; \
1599         RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1600         for file in $$RELSRCS; do \
1601                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1602                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1603         done ; \
1604         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1605                 -t ganeti-htools -p haddock-prologue \
1606                 --source-module="%{MODULE/.//}.html" \
1607                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1608                 $$OPTGHC \
1609                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1610
1611 .PHONY: TAGS
1612 TAGS: $(GENERATED_FILES)
1613         rm -f TAGS
1614         $(GHC) -e ":etags" -v0 $(HFLAGS) $(HS_LIBTEST_SRCS)
1615         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1616           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1617           -path './qa/*.py' | \
1618           etags -l python -a -
1619
1620 .PHONY: coverage
1621 if WANT_HTOOLS
1622 coverage: py-coverage hs-coverage
1623 else
1624 coverage: py-coverage
1625 endif
1626
1627 .PHONY: py-coverage
1628 py-coverage: $(GENERATED_FILES) $(python_tests)
1629         set -e; \
1630         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1631         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1632         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1633         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1634         $(python_tests)
1635
1636 .PHONY: hs-coverage
1637 hs-coverage: $(haskell_tests) htest/hpc-htools
1638         rm -f *.tix
1639         $(MAKE) $(AM_MAKEFLAGS) hs-check
1640         @mkdir_p@ $(COVERAGE_HS_DIR)
1641         hpc combine --union $(HPCEXCL) \
1642           test.tix hpc-htools.tix > coverage-htools.tix
1643         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1644         hpc report coverage-htools.tix
1645         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1646
1647 # Special "kind-of-QA" target for htools, needs special setup (all
1648 # tools compiled with -fhpc)
1649 .PHONY: live-test
1650 live-test: all
1651         set -e ; \
1652         cd htools; \
1653         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1654         rm -f *.tix *.mix; \
1655         ./live-test.sh; \
1656         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1657           --output=live-test.tix ; \
1658         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1659         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1660                 --srcdir=.. $(HPCEXCL) ; \
1661         hpc report --srcdir=.. live-test $(HPCEXCL)
1662
1663 commit-check: distcheck lint apidoc
1664
1665 .PHONY: gitignore-check
1666 gitignore-check:
1667         @if [ -n "`git status --short`" ]; then \
1668           echo "Git status is not clean!" 1>&2 ; \
1669           git status --short; \
1670           exit 1; \
1671         fi
1672
1673 # we don't need the ancient implicit rules:
1674 %: %,v
1675 %: RCS/%,v
1676 %: RCS/%
1677 %: s.%
1678 %: SCCS/s.%
1679
1680 -include ./Makefile.local
1681
1682 # vim: set noet :